
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Conference_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conference_events = await db.conference_events.create(
            {
                id: data.id || undefined,
        
        event_kind: data.event_kind
        ||
        null
            ,
            
        event_key: data.event_key
        ||
        null
            ,
            
        event_at: data.event_at
        ||
        null
            ,
            
        payload: data.payload
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await conference_events.setConference( data.conference || null, {
            transaction,
        });
        
        await conference_events.setEvent_stream( data.event_stream || null, {
            transaction,
        });
        
        await conference_events.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return conference_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const conference_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_kind: item.event_kind
            ||
            null
            ,
            
                event_key: item.event_key
            ||
            null
            ,
            
                event_at: item.event_at
            ||
            null
            ,
            
                payload: item.payload
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const conference_events = await db.conference_events.bulkCreate(conference_eventsData, { transaction });

        // For each item created, replace relation files
        

        return conference_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const conference_events = await db.conference_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_kind !== undefined) updatePayload.event_kind = data.event_kind;
        
        
        if (data.event_key !== undefined) updatePayload.event_key = data.event_key;
        
        
        if (data.event_at !== undefined) updatePayload.event_at = data.event_at;
        
        
        if (data.payload !== undefined) updatePayload.payload = data.payload;
        
        
        updatePayload.updatedById = currentUser.id;

        await conference_events.update(updatePayload, {transaction});

        
        
        if (data.conference !== undefined) {
            await conference_events.setConference(
              
              data.conference,
              
              { transaction }
            );
        }
        
        if (data.event_stream !== undefined) {
            await conference_events.setEvent_stream(
              
              data.event_stream,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await conference_events.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return conference_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conference_events = await db.conference_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of conference_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of conference_events) {
                await record.destroy({transaction});
            }
        });


        return conference_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const conference_events = await db.conference_events.findByPk(id, options);

        await conference_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await conference_events.destroy({
            transaction
        });

        return conference_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const conference_events = await db.conference_events.findOne(
            { where },
            { transaction },
        );

        if (!conference_events) {
            return conference_events;
        }

        const output = conference_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conference = await conference_events.getConference({
            transaction
        });
        
        
        output.event_stream = await conference_events.getEvent_stream({
            transaction
        });
        
        
        output.organizations = await conference_events.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.conferences,
        as: 'conference',
        
        where: filter.conference ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conference.split('|').map(term => Utils.uuid(term)) } },
            {
              conference_key: {
                [Op.or]: filter.conference.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.event_streams,
        as: 'event_stream',
        
        where: filter.event_stream ? {
          [Op.or]: [
            { id: { [Op.in]: filter.event_stream.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.event_stream.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.event_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'conference_events',
                        'event_key',
                        filter.event_key,
                    ),
                };
            }
            
            if (filter.payload) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'conference_events',
                        'payload',
                        filter.payload,
                    ),
                };
            }
            

            
            

            
            if (filter.event_atRange) {
                const [start, end] = filter.event_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    event_at: {
                    ...where.event_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    event_at: {
                    ...where.event_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_kind) {
                where = {
                    ...where,
                event_kind: filter.event_kind,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.conference_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'conference_events',
                        'event_kind',
                        query,
                    ),
                ],
            };
        }

        const records = await db.conference_events.findAll({
            attributes: [ 'id', 'event_kind' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_kind', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_kind,
        }));
    }

    
};

